﻿Public Class IvrInteractive
  Public Sub New()
    InitializeComponent()
    ' Subscribe to the application log message handler and drive Log_MessageLogged
    AddHandler IvrApplication.Log.MessageLogged, AddressOf Log_MessageLogged  'A&&&&
    'D&&&&IvrApplication.Log.MessageLogged += New MessageLogged(Log_MessageLogged)
  End Sub
  ' This logs messages from the TelephonyBank to your application log.
  Private Delegate Sub dlgMessageLogged(ByVal message As String)
  Sub Log_MessageLogged(ByVal message As String)
    If Me.InvokeRequired Then
      Dim ml As New dlgMessageLogged(AddressOf Log_MessageLogged)
      Me.Invoke(ml, message)
      Return
    End If

    If txtLog.Text.Length > 15000 Then
      txtLog.Text = txtLog.Text.Substring(txtLog.Text.Length - 15000) + message
    Else
      txtLog.Text = txtLog.Text + message
    End If

    txtLog.SelectionStart = txtLog.Text.Length
    txtLog.ScrollToCaret()
  End Sub

  Private Sub IvrInteractive_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) Handles MyBase.FormClosing
    Dim dr As DialogResult = MessageBox.Show("Do you really want to shutdown the application?", "Close?", MessageBoxButtons.YesNo)
    If dr = DialogResult.No Then
      e.Cancel = True
      Return
    End If

    ' Stop Logging messages
    RemoveHandler IvrApplication.Log.MessageLogged, AddressOf Log_MessageLogged 'A&&&&
    'R&&&&IvrApplication.Log.MessageLogged -= New MessageLogged(Log_MessageLogged)

    ' This destroys the connection to the Telephony Bank.
    IvrApplication.StopImmediate()

  End Sub

  Private Sub IvrInteractive_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
    ' When the form loads, it starts the connection to the Telephony Bank.
    ' You could move this to a start button if you dont want the connection established immediately.
    IvrApplication.Start()
  End Sub
End Class
