﻿Imports System
Imports System.Collections.Generic
Imports System.Windows.Forms
Imports System.Diagnostics
Imports System.ServiceProcess

Namespace VoiceApp
  Class Program

    ' This is the name of the service that will be installed on your system.
    Private Shared s_ServiceName As String = "Ivr"

    Public Shared ReadOnly Property ServiceName() As String
      Get
        Return Program.s_ServiceName
      End Get
    End Property

    ' This is the descriptive text associated with your service.
    Private Shared s_DisplayName As String = "Ivr Service"

    Public Shared ReadOnly Property DisplayName() As String
      Get
        Return Program.s_DisplayName
      End Get
    End Property

    ''' <summary>
    ''' The main entry point for the application.
    ''' </summary>
    <MTAThread()> _
    Shared Sub Main()
      Dim sProcessName As String = Process.GetCurrentProcess().ProcessName

      If Environment.UserInteractive Then
        If sProcessName.ToLower() <> "services.exe" Then
          ' Im an interactive session.
          Application.EnableVisualStyles()
          Application.SetCompatibleTextRenderingDefault(False)
          Application.Run(New IvrInteractive())
          Return

        End If
      End If

      Dim ServicesToRun As ServiceBase()

      ServicesToRun = New ServiceBase() {New IvrService()}

      ServiceBase.Run(ServicesToRun)
    End Sub
  End Class
End Namespace